var imageBoxHeights = new Array();//记录所有图片外层div的高度
var imageIndexs = new Array();//每个图片位置
var imageDisplayed = new Array();//记录哪些图片已经显示，避免重复显示
var imageDownloading = new Array();//记录哪些图片在下载,避免滑动时重复下载
var bigImageDownloading = new Array();//记录gif在下载
var gifImageSrc = new Array();//gif图片路径
var gifImageNormalSrc = new Array();//gif静态图片路径
var gifImageSrc = new Array();//gif动态图片路径
var isGifTag = new Array();//标记是否gif
var isGifShowed = new Array();//标记git动图是否显示
var gifDownloadProgress = new Array();//标记git动图下载进度

var longGifFlagWidth;//长图gif标识宽度
var longGifFlagHeight;//长图gif标识高度
var isArticleVisible = true;//标记文章是否可见

//获取元素距离顶部的距离,单位dp
function getElementOffsetTop(element) {
	var mTop = element.offsetTop;//获取元素距离顶部的距离
	//  var sTop = document.body.scrollTop;
	//  var result = mTop - sTop;//减去滚动条的高度就是相对顶部的高度
	return mTop;
}

//判断图片是否在屏幕可见范围
function isImageInScreen(index, scrollY, screenHeight) {
	var imgbox = document.getElementById('id_imagebox_' + index);
	var offsetTop = getElementOffsetTop(imgbox);//图片距离顶部的高度
	var imgBoxHeight = imageBoxHeights[index];//图片高度
	var offsetBottom = offsetTop + imgBoxHeight;//图片底部距离顶部高度
	var lineTopPosition = scrollY;//可见范围上分界线
	var lineBottomPosition = scrollY + screenHeight;//可见范围下分界线
	if ((offsetTop > (lineTopPosition - imgBoxHeight))
		&& (offsetBottom < (lineBottomPosition + imgBoxHeight))) {
		//图片在屏幕可见范围则显示
		return true;
	}
	return false;
}

//显示gif播放标识
function showGifFlag(imgbox, index) {
	var gifFlag = document.getElementById('id_gif_flag_' + index);//gif标识
	if (!gifFlag) {//判断是否有gif标识，没有则添加
		var gifFlag = document.createElement("img");
		var imgBoxHeight = imageBoxHeights[index];//图片高度
		gifFlag.setAttribute("id", "id_gif_flag_" + index);

		var flagWidth = longGifFlagWidth;
		var flagHeight = longGifFlagHeight;

		gifFlag.src = "file:///android_asset/html/news_template_list/longGifFlag.png";
		gifFlag.style.width = flagWidth + "px";
		gifFlag.style.height = flagHeight + "px";
		gifFlag.style.bottom = "0px";
		gifFlag.style.top = "0px";
		gifFlag.style.left = "0px";
		gifFlag.style.right = "0px";
		gifFlag.style.margin = "auto";
		gifFlag.style.position = "absolute";
		imgbox.appendChild(gifFlag);
	}
	// gifFlag.style.display = "inline";
}

//隐藏gif播放标识
function hideGifFlag(imgbox, index) {
	var gifFlag = document.getElementById('id_gif_flag_' + index);//gif标识
	if (gifFlag) {
		//   gifFlag.style.display = "none";
		imgbox.removeChild(gifFlag);
	}
}
//重置gif图片状态，变为静态图
function resetGifImageStat(index, isSpecialPhone, isNeedHideLoading) {
	var img = document.getElementById('id_image_' + index);
	var imgbox = document.getElementById('id_imagebox_' + index);
	// handleImageLoading(index, imgbox, true, false);//隐藏loading

	if (gifImageNormalSrc[index]) {//显示静态图
		img.src = gifImageNormalSrc[index];
		img.style.display = "block";
	}
	//显示灰色遮罩
	showGifImageShade(index, isNeedHideLoading);

	if (bigImageDownloading[index] && isArticleVisible) {//gif正在下载则隐藏gif标识
		hideGifFlag(imgbox, index);
	} else {
		showGifFlag(imgbox, index);//显示gif标识
	}

	isGifShowed[index] = false;//标记gif动图未显示
	//gif图点击之后加载gif图

	addClickLoadBigImageListener(index, true, isSpecialPhone);
}

/**
 * 停止所有gif动图 
 * @param {*} isSpecialPhone 是否特殊机型
 * @param {*} isChangeArticle  是否切换文章
 */
function stopAllGif(isSpecialPhone, isChangeArticle) {
	if (isChangeArticle) {
		isArticleVisible = false;
		console.log('切换文章');
	}
	console.log('开始停止所有gif');
	stopOtherGif(0, 0, isSpecialPhone);
}

//滑动时停止播放所有的gif图
function stopOtherGif(scrollY, screenHeight, isSpecialPhone) {
	//文章不可见时重置所有gif为静态图
	if (!isArticleVisible) {
		for (var index = 0; index < isGifTag.length; index++) {
			if (!isGifTag[index] || index == "contains" || typeof (gifImageSrc[index]) == "function") {
				continue;
			}
			console.log(index + '开始重置gif状态');
			resetGifImageStat(index, isSpecialPhone, true);
		}

		return;
	}

	for (var index = 0; index < gifImageSrc.length; index++) {
		if (index == "contains" || typeof (gifImageSrc[index]) == "function"
			|| !isGifTag[index]
			|| bigImageDownloading[index]
			|| !isGifShowed[index]) {
			//非gif图或者正在下载图片
			continue;
		}

		var imgbox = document.getElementById('id_imagebox_' + index);
		var img = document.getElementById('id_image_' + index);
		if (isImageInScreen(index, scrollY, screenHeight)) {//gif图片在可见范围则不更改
			continue;
		}
		resetGifImageStat(index, isSpecialPhone, true);

	}
}

//添加点击图片加载大图事件
function addClickLoadBigImageListener(index, isGif, isSpecialPhone) {
	var imgbox = document.getElementById('id_imagebox_' + index);
	//gif图点击之后加载gif图
	imgbox.onclick = function () {
		if (isGif) {
			if (isSpecialPhone) {//4.4以下机型点击直接查看大图
				downloadImage(index);
				return;
			}
		}
		loadBigImage(imgbox, index, isGif, true, true);
	};
}

//显示gif图片遮罩
function showGifImageShade(index, isNeedHideLoading) {
	var gifImageBox = document.getElementById('id_imagebox_' + index);
	var gifShade = document.getElementById('id_blackBgDiv' + index);
	var gifFlag = document.getElementById('id_gif_flag_' + index);//gif标识
	if (gifShade) {//已经显示则返回
		//去掉loading
		if (isNeedHideLoading) {
			hideGifImgaeLoading(index, false);
			console.log(index + "已去掉loading");
		}
		return;
	}
	gifShade = createLoadingBgView(index);

	gifImageBox.appendChild(gifShade);

	if (gifFlag) {//如果新增灰色遮罩时已经存在gif标签，则先移除，再显示，避免gif标识被灰色遮罩遮住
		gifFlag.remove();
		showGifFlag(gifImageBox, index);
	}

}

/**
 * 隐藏gif的loading，允许保留灰色遮罩
 * @param {number} index 图片位置
 * @param {boolean} isRemove 是否移除灰色遮罩
 */
function hideGifImgaeLoading(index, isRemove) {
	var gifShade = document.getElementById('id_blackBgDiv' + index);
	if (gifShade) {
		if (isRemove) {//移除灰色遮罩
			gifShade.remove();
			return;
		}
		//保留灰色遮罩，去掉进度
		gifShade.innerHTML = "";
	}
}

//创建loading背景色块
function createLoadingBgView(index) {
	var blackBgDiv = document.createElement("div");
	blackBgDiv.setAttribute("id", "id_blackBgDiv" + index);
	blackBgDiv.style.width = "100%";
	blackBgDiv.style.height = imageBoxHeights[index] + "px";

	blackBgDiv.style.position = "absolute";
	blackBgDiv.style.top = "0";
	blackBgDiv.style.left = "0";
	blackBgDiv.style.background = "rgba(0, 0, 0, 0.3)";
	//	blackBgDiv.className = "ImageBlackTransparent";

	blackBgDiv.style.borderRadius = "5px";
	return blackBgDiv;
}

//显示图片加载loading
function handleImageLoading(index, imgbox, isGif, showLoading) {
	if (isGif) {
		if (!showLoading) {
			//隐藏gifloading
			hideGifImgaeLoading(index, true);
		} else {
			updateGifProgress(index, 1);
		}
		return;
	}
	var loadingImg = document.getElementById('id_loading' + index);
	var blackBgDiv = document.getElementById('id_blackBgDiv' + index);
	if (showLoading) {//显示loading
		if (!loadingImg) {//判断是否有loading图片，没有则添加
			var loadingImg = document.createElement("img");
			loadingImg.setAttribute("id", "id_loading" + index);
			loadingImg.src = "file:///android_asset/html/news_template_list/loading.gif";
			loadingImg.style.position = "absolute";
			loadingImg.style.width = "34px";
			loadingImg.style.height = "6px";
			loadingImg.style.top = "50%";
			loadingImg.style.left = "50%";
			loadingImg.style.webkitTransform = "translate(-50%, -50%)";
			loadingImg.style.transform = "translate(-50%, -50%)";
			imgbox.appendChild(loadingImg);
		}
		return;
	}
	//去除loading
	if (loadingImg) {//判断是否有loading图片，有则隐藏
		imgbox.removeChild(loadingImg);
	}
}

/**
 * 检查gif动图下载状态
 */
function checkGifDownloadingStat(index) {
	if (bigImageDownloading[index] && gifImageSrc[index]) {
		//如果状态标记是正在下载，但是已经显示过gif动图，则重置下载状态
		bigImageDownloading[index] = false;
	}
}

/**
 * 点击小图加载大图/加载gif
 * @param {Element} imgbox 图片所在div
 * @param {String} index 图片位置
 * @param {boolean} isGif 是否gif
 * @param {boolean} isUserClick 是否用户点击加载大图
 * @param {boolean} isNetworkNormal 网络是否正常(需要从客户端判断，网页里判断不准)
 */
function loadBigImage(imgbox, index, isGif, isUserClick, isNetworkNormal) {
	if ((bigImageDownloading[index] || !isNetworkNormal) && !gifImageSrc[index]) {
		//如果正在下载状态或者无网络下，并且没有加载过gif图，则直接返回
		var downloadProgress = gifDownloadProgress[index];
		if (downloadProgress) {//已经在下载的gif显示下载进度
			console.log("正在下载" + index + ":恢复进度->" + downloadProgress);
			updateGifProgress(index, downloadProgress);
		}
		if (!isNetworkNormal) {
			console.log("网络异常!->" + index);
		}
		return;
	}
	bigImageDownloading[index] = true;
	if (isGif) {
		hideGifFlag(imgbox, index);
	}
	if (!gifImageSrc[index]) {//之前加载过gif则不显示loading
		handleImageLoading(index, imgbox, isGif, true);//显示loading
	}

	//8.0.3之前此处为 href = "loadBigImage"，因部分 7.0 以上系统机型出现崩溃故变更为下面的代码
	//  document.location.href = "zkmedia://zk-cmd/logic/?_zkcmd=load_media&index=" + index;

	prompt("load_media", index + "&" + (isUserClick ? "1" : "0"));
}

//点击查看大图
function downloadImage(mess) {
	//8.0.3之前此处为 href = "image"，因部分 7.0 以上系统机型出现崩溃故变更为下面的代码
	window.location.href = "zkmedia://zk-cmd/logic/?_zkcmd=open_media&index=" + mess;
}

//将下载好的图片插入文章中
function insertImageSrc(imageSrc, index, gifUrl, isMinUrl, isNight
	, isGif, isSpecialPhone, scrollY, screenHeight, isLoadBigImage) {
	//清除正在加载的标记
	if (!isLoadBigImage) {
		imageDownloading[index] = false;
	} else {//加载大图
		bigImageDownloading[index] = false;
		gifDownloadProgress[index] = null;
	}

	console.log('加载完成:' + index + ':' + isLoadBigImage);
	var img = document.getElementById('id_image_' + index);
	var imgbox = document.getElementById('id_imagebox_' + index);
	imgbox.style.position = "relative";
	var isGifInScreen = true;//gif图是否在屏幕显示范围
	if (!isGif) {//处理非gif图片的loading
		handleImageLoading(index, imgbox, false, false);//隐藏loading
	} else {
		//gif
		//保存gif静态图片地址
		if (imageSrc) {
			gifImageNormalSrc[index] = imageSrc;
		}
		//保存gif动图
		if (gifUrl) {
			gifImageSrc[index] = gifUrl;
		}
		isGifInScreen = isImageInScreen(index, scrollY, screenHeight);
	}

	if (!isArticleVisible) {//当前文章不可见则返回
		return;
	}

	if ((!imageSrc && !gifUrl) || (isGif && !isGifInScreen && isLoadBigImage)) {
		if (isGif) {//重置gif图片为静态图
			resetGifImageStat(index, isSpecialPhone, true);
		}

		handleImageLoading(index, imgbox, isGif, false);//隐藏loading
		return;
	}

	//标记该图片已经显示
	imageDisplayed[index] = index;

	if (isGif) {//处理gif显示
		//保存gif静态图片地址
		// if(!gifImageNormalSrc[index]){
		// 	gifImageNormalSrc[index] = imageSrc;
		// }
		if (gifUrl && !isSpecialPhone) {//播放gif图,android5.0以下特殊机型则不播放gif,避免点击查看大图失效

			//隐藏gif标识
			hideGifFlag(imgbox, index);

			handleImageLoading(index, imgbox, true, false);//隐藏loading
			if (isGifInScreen && isGifShowed[index]) {
				//gif在屏幕可见范围并且已经显示
				return;
			}
			// stopOtherGif(scrollY, screenHeight, index);//停止播放其他gif图
			isGifShowed[index] = true;//标记gif动图已经显示
			//显示gif图
			img.src = gifUrl;
			img.style.display = "block";
			//保存gif图片路径
			gifImageSrc[index] = gifUrl;
			imgbox.onclick = function () {
				downloadImage(index);
			};
			return;
		}
		//gif还没下载,显示静态图
		resetGifImageStat(index, isSpecialPhone, isLoadBigImage);

		return;
	}

	if (imageSrc) {
		img.src = imageSrc;
		img.style.display = "block";
	}

	if (isMinUrl) {//小图则显示一半大小
		if (isNight) {//改变图片占位符背景色
			imgbox.style.backgroundColor = "#151515";
		} else {
			imgbox.style.backgroundColor = "#ffffff";
		}
		imgbox.style.height = imageBoxHeights[index] / 2 + "px";
		img.style.height = imageBoxHeights[index] / 2 + "px";
		img.style.width = "50%";
		img.style.margin = "0 auto";

		//小图点击之后开始加载大图
		addClickLoadBigImageListener(index, false, isSpecialPhone);
		return;
	}

	imgbox.style.height = imageBoxHeights[index] + "px";
	img.style.width = "100%";
	img.style.height = "100%";

	imgbox.onclick = function () {
		downloadImage(index);
		return false;
	};

}

//根据滑动距离处理图片的显示
function handleImageDisplay(scrollY, screenHeight, isNeedReset, isWifi, SDK_INT, isNetworkNormal) {
	isArticleVisible = true;
	//scrollY滚动的距离，screenHeight屏幕的高度,isNeedReset是否需要清除图片已经显示的标记
	if (isNeedReset) {//用于查看大图返回后显示大图
		imageDisplayed = new Array();
		//清除正在加载的标记
		imageDownloading = new Array();
		bigImageDownloading = new Array();
	}
	if (SDK_INT < 23) {
		//低于android6.0不自动加载gif图片
		return;
	}
	console.log("处理屏幕图片显示:[下载中]" + bigImageDownloading);
	for (var index = 0; index < imageIndexs.length; index++) {
		console.log('正在处理:' + index);
		if (!isGifTag[index] || isGifShowed[index] || index == "contains" || typeof (imageIndexs[index]) == "function") {
			console.log('跳过：' + index);
			// console.log('跳过加载动图:'+index+';isGifTag:'+isGifTag[index]+';
			//			isGifShowed:'+isGifShowed[index]+';imageDownloading:'+imageDownloading[index]);
			continue;
		}
		//检查gif动图下载状态
		checkGifDownloadingStat(index);

		var imgbox = document.getElementById('id_imagebox_' + index);
		if (!imgbox || (!isWifi && !gifImageSrc[index])) {//文章模板找不到对应图片所在div,或者非gif图
			console.log('找不到元素:' + index + ';imgbox:' + imgbox + ';isWifi:' +
				isWifi + ';gifImageSrc:' + gifImageSrc[index]);
			continue;
		}

		if (isImageInScreen(index, scrollY, screenHeight)) {//判断图片是否在可见范围
			//加载gif图片
			console.log('开始加载动图:' + index);
			loadBigImage(imgbox, index, true, false, isNetworkNormal);
			continue;
		} else {
			console.log("不在屏幕范围:" + index + ';scrollY:' + scrollY + ';screenHeight:' + screenHeight);
		}
	}
}

//初始化单个图片高度
function initImageHeight(i, originalWidth, originalHeight, isNight, isGif) {

	var img = document.getElementById('id_image_' + i);
	img.style.display = "none";

	var imgbox = document.getElementById('id_imagebox_' + i);
	var imgboxWidth = imgbox.offsetWidth;
	if (imgboxWidth == undefined) {
		imgboxWidth = imgbox.clientWidth;
	}

	if (!longGifFlagWidth) {//长gif图标识宽度
		longGifFlagWidth = imgboxWidth * 37 / 527;
	}
	if (!longGifFlagHeight) {//长gif图标识高度
		longGifFlagHeight = longGifFlagWidth * 44 / 77;
	}

	var height = Math.floor(imgboxWidth * (originalHeight / originalWidth));

	//TODO opt ? 保存每个图片的位置
	imageIndexs[i] = i;
	imageBoxHeights[i] = height;
	isGifTag[i] = isGif;

	if (imgbox != undefined && height != 0) {
		imgbox.style.height = height + "px";
		if (isNight) {//改变图片占位符背景色
			imgbox.style.backgroundColor = "#000000";
		} else {
			imgbox.style.backgroundColor = "#f8f8f8";
		}
		imgbox.onclick = (function (i) {
			var clickIndex = i;
			return function () {
				downloadImage(clickIndex);
				return false;
			};
		})(i);
	}
}

/**
 * 初始化所有图片高度
 * @param {array} mediaArray 图片信息数组
 * @param {boolean} isNight 是否夜间模式
 */
function initAllImageHeight(mediaArray, isNight) {
	var width;
	var height;

	for (var i = 0; i < mediaArray.length && i <= MAX_INIT_IMAGE_COUNT; i++) {
		width = mediaArray[i][ARTICLE_CONTENT_MEDIA_WIDTH_KEY];
		height = mediaArray[i][ARTICLE_CONTENT_MEDIA_HEIGHT_KEY];
		var isGif = mediaArray[i][IS_GIF_KEY];
		if (width == 0 || height == 0) {
			continue;
		}
		initImageHeight(i, width, height, isNight, isGif);
	}
}

/**
 *  loading图加载进度
 *  @param {string} parentSelector gif图父层选择器
 *  @param {string} imgSelector gif图选择器
 *  @param {number} percent gif图加载百分比
 *  @param {number} scrollY 当前网页上下滑动距离
 *  @param {number} screenHeight 屏幕高度
*/
function updateGifProgress(index, percent, scrollY, screenHeight) {
	gifDownloadProgress[index] = percent;//保存下载进度

	var isInScreen = true;
	if (scrollY != undefined && screenHeight != undefined) {
		isInScreen = isImageInScreen(index, scrollY, screenHeight);
	}

	if (!isArticleVisible || !isInScreen) {
		console.log(index + "文章不可见，取消更新进度");
		return;
	}
	console.log(index + "更新下载进度:" + percent);
	var img = document.getElementById('id_image_' + index);
	var parent = document.getElementById('id_imagebox_' + index);
	var gifDom = document.getElementById('id_blackBgDiv' + index);
	var svgObj;
	var imgWidth = parent.offsetWidth;
	var imgHeight = parent.offsetHeight;
	var length = imgWidth * (200 / 690);

	hideGifFlag(parent, index);

	if (percent >= 100) {
		if (gifDom) {
			var circle = gifDom.querySelector('.linerLoading');
			if (circle == undefined) {
				gifDom.remove();
				return;
			}
			circle.style.width = length * (percent / 100) + 'px';
			gifDom.remove();
			//			setTimeout(function () {
			//				gifDom.remove();
			//			}, 500);
			return;
		}
	} else {
		if (gifDom == undefined) {
			if (parent.style.position == 'static' || parent.style.position == '') {
				parent.style.position = 'relative';
			}
			gifDom = createLoadingBgView(index);
			parent.appendChild(gifDom);
			svgObj = new lineLoading(gifDom, imgWidth);
		}
		var circle = gifDom.querySelector('.linerLoading');
		if (circle == undefined) {
			svgObj = new lineLoading(gifDom, imgWidth);
			circle = gifDom.querySelector('.linerLoading');
		}
		circle.style.width = length * (percent / 100) + 'px';
	}
}

//水平加载动画
function lineLoading(el, length) {
	this.el = el;
	this.length = length * (200 / 690) || 320;
	this.wrapper = document.createElement('div');
	this.wrapper.setAttribute('class', 'linerLoadingWrapper');
	this.wrapper.setAttribute('style', 'position:absolute;top:50%;left:50%;margin-top: -3px;height:4px;border-radius:4px;overflow:hidden;background:rgba(255, 255, 255, 0.5);width:' + this.length + 'px; margin-left:-' + this.length / 2 + 'px');
	this.inner = document.createElement('div');
	this.inner.setAttribute('style', 'position:relative;z-index:100;height:4px;background:#fff;width:1px;transition: all 500ms cubic-bezier(0.42,0,0.832,0.988)');
	this.inner.setAttribute('class', 'linerLoading');
	this.wrapper.appendChild(this.inner);
	this.el.appendChild(this.wrapper);
}
